<?php

defined('ABSPATH') or die("No script kiddies please!");

class failed_login_firewall_admin extends failed_login_firewall_base {

	private static $initiated = false;
	private static $o;
	
	public static function init() {
		if ( ! self::$initiated ) {
			self::init_hooks();
		}
		
		self::$o = get_option("failed_login_firewall_options");
	}
	
	private static function init_hooks() {
		self::$initiated = true;
		
		add_action( 'admin_menu', array("failed_login_firewall_admin", "admin_menu" ) );
	}
	
	
	public static function activate() {
		
		
	}
	
	public static function admin_menu() {
		add_options_page( 'Failed login firewall', 'Failed login firewall settings', 'manage_options', 'failed_login_firewall_configuration', array("failed_login_firewall_admin", "admin_menu_options") );
	}
	
	
	public static function admin_menu_options() {
		if ( !current_user_can( 'manage_options' ) )  {
			wp_die( __( 'You do not have sufficient permissions to access this page.' ) );
		}
		
		
		if (isset($_POST["subaction"]) && $_POST["subaction"]=="save_options") {
		
			$set_options = self::$o;
			$set_options["site_key"]=self::$o["site_key"];
			$set_options["site_url"]=site_url();
			
			update_option("failed_login_firewall_options", $set_options);
			self::do_report(array("action"=>"update_site", "site_key"=>$set_options["site_key"], "site_url"=>$set_options["site_url"]));
			
			
			self::$o = $set_options;
			
			print("
				<div class='updated'><p><strong>".__('settings saved.')."</strong></p></div>
			");
		}
		
		
		
		
		print("
		<div class='wrap'>
			<h2>".__("Failed login firewall")."</h2>
		
			<form action='' method='post' class='form-horizontal'>
			<input type='hidden' name='subaction' value='save_options'>
			
			<table class='form-table'>
				<tbody>
					
					<tr>
						<th scope='row'>
							<label class='col-sm-2 control-label'>".__("Your site key")."</label>
						</th>
						<td>
							<b>".self::$o["site_key"]."</b>
						</td>
					</tr>
					
					
					
					
				</tbody>
			</table>
			
			<p class='submit'>
				<input class='button button-primary' type='submit' value='".__("Save settings!")."'>
			</p>
			
			</form>
		</div>
		");
		
	}
}