<?php
defined('ABSPATH') or die("No script kiddies please!");

class failed_login_firewall extends failed_login_firewall_base {
	private static $initiated = false;
	
	private static $o;

	public static function init() {
		if ( ! self::$initiated ) {
			self::init_hooks();
		}


		self::$o = get_option("failed_login_firewall_options");
	}
	
	private static function init_hooks() {
		self::$initiated = true;
		
		add_action( 'wp_login_failed', array('failed_login_firewall', 'report') ); // hook failed login
	}
	

	
	
	public static  function report($username) {
		$referrer = $_SERVER['HTTP_REFERER']; // where did the post submission come from?
		
		
		$url = home_url();
		
		if (isset($_SERVER["HTTP_X_FORWARDED_FOR"]) && $_SERVER["HTTP_X_FORWARDED_FOR"]!="")
			$report_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
		else
			$report_ip = $_SERVER["REMOTE_ADDR"];
		
        // if there's a valid referrer, and it's not the default log-in screen
        self::do_report(array("action"=>"wrong_user", "failed_user"=>$username, "referrer"=>$referrer, "url"=>$url, "visitor_ip"=>$report_ip, "server_timestamp"=>time(), "login_referrer"=>$_SERVER["HTTP_REFERRER"], "site_key"=>self::$o["site_key"]));
	}
	
	
	public static  function plugin_deactivation() {
		
	}
	
	public static  function plugin_activation() {
		# save wordpress settings.
		if (!isset(self::$o["include_global_list"])) {
			$odef = array(
				"include_global_list"=>0,
				"site_key"=>"",
				"notificate_admin"=>0,
				"site_url"=>site_url()
			);
			
			update_option("failed_login_firewall_options", $odef);
			self::$o=$odef;
		}
		
		$site_url = site_url();
		
		$p = array("action"=>"register_site", "site_url"=>$site_url, "site_key"=>self::$o["site_key"]);
		$res = self::do_report($p);
		
		
		if (isset($res["site_key"])) {
			if ($res["site_key"]!="") {
				self::$o["site_key"]=$res["site_key"];
				update_option("failed_login_firewall_options", self::$o);
			}
		}
		
		return true;
	}
}
