<?php
/**
 * @package Failed Login Firewall
 */
/*
Plugin Name: Failed Login Firewall reporting
Plugin URI: http://wp-firewall.hosting.guru/
Description: Plugin reports failed login attempts to central database. Server administrator can use this global list to block access to server and provide protection against brute force attacks on firewall level. Please visit plugin webpage for more details.
Version: 0.32
Author: Anton Aleksandrov
Author URI: http://anton.aleksandrov.eu
License: GPLv2 or later
*/

defined('ABSPATH') or die("No script kiddies please!");


define('FAILED_LOGIN_FIREWALL_DIR', dirname(__FILE__));

register_activation_hook( __FILE__, array( 'failed_login_firewall', 'plugin_activation' ) );
register_deactivation_hook( __FILE__, array( 'failed_login_firewall', 'plugin_deactivation' ) );

require_once(FAILED_LOGIN_FIREWALL_DIR."/class.failed_login_firewall.php");


add_action( 'init', array( 'failed_login_firewall', 'init' ) );




if ( is_admin() ) {
	require_once( FAILED_LOGIN_FIREWALL_DIR . '/class.failed_login_firewall.admin.php' );
	add_action( 'init', array( 'failed_login_firewall_admin', 'init' ) );
	#register_activation_hook(__FILE__, array('failed_login_firewall_admin', 'activate'));
}


class failed_login_firewall_base {
	public static function do_report($p) {
		#mail("anton@nordichosting.com", "failed login: ".$p["action"], print_r($p,true));
		
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL,"https://wp-firewall.hosting.guru/register.php");
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS,
					http_build_query($p));

		
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		$server_output = curl_exec($ch);

		curl_close ($ch);
		
		return(json_decode($server_output,true));
		#return(true);
	}
}



/*

if (!function_exists("failed_login_do_report")) {
	function failed_login_do_report($params=array()) {
		
		mail("anton@nordichosting.com", "failed login: ".$params["action"], print_r($params,true));
		
	}
}

if( ! function_exists( 'report_failed_login_to_firewall' ) ) {
    function report_failed_login_to_firewall( $username ) {
        $referrer = $_SERVER['HTTP_REFERER']; // where did the post submission come from?
		
		
		$url = home_url();
		$admin_email = get_bloginfo("admin_email");
		
        // if there's a valid referrer, and it's not the default log-in screen
        failed_login_do_report(array("action"=>"wrong_user", "failed_user"=>$username, "referrer"=>$referrer, "url"=>$url, "admin_email"=>$admin_email, "visitor_ip"=>$_SERVER["REMOTE_ADDR"]));
    }
}
*/
/*
if( ! function_exists( 'report_empty_login_to_firewall' ) ) {
    function report_empty_login_to_firewall(){
        $referrer = $_SERVER['HTTP_REFERER'];
        if ( strstr($referrer,get_home_url()) && $user==null ) { // mylogin is the name of the loginpage.
            failed_login_do_report(array("action"=>"empty_login", "referrer"=>$referrer, "url"=>$url, "admin_email"=>$admin_email, "visitor_ip"=>$_SERVER["REMOTE_ADDR"]));
        }
    }
}
*/


#add_action( 'authenticate', 'report_empty_login_to_firewall');